       IDENTIFICATION DIVISION.
       PROGRAM-ID.    CALLPEC2.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      *           This program was generated by SimoZAPS              *
      *             A product of SimoTime Technologies                *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *  An I/O Module for a New Sequential File with Fixed, 80-Byte  *
      *                                                               *
      *                                   Record    Record     Key    *
      *  Function  Name     Organization  Format    Max-Min  Pos-Len  *
      *  OUTPUT    SIMOSEQ1 SEQUENTIAL    FIXED      00080            *
      *****************************************************************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT SIMOSEQ1-FILE  ASSIGN TO       SIMOSEQ1
                  ORGANIZATION  IS SEQUENTIAL
                  ACCESS MODE   IS SEQUENTIAL
                  FILE STATUS   IS SIMOSEQ1-STATUS.

      *****************************************************************
       DATA DIVISION.
       FILE SECTION.
       FD  SIMOSEQ1-FILE
           DATA RECORD    IS SIMOSEQ1-REC.
       01  SIMOSEQ1-REC.
           05  SIMOSEQ1-DATA-01 PIC X(80).

      *****************************************************************
       WORKING-STORAGE SECTION.
       01  SIMOSEQ1-STATUS.
           05  SIMOSEQ1-STATUS-L     pic X.
           05  SIMOSEQ1-STATUS-R     pic X.
       01  SIMOSEQ1-EOF              pic X       value 'N'.
       01  SIMOSEQ1-OPEN-FLAG        pic X       value 'C'.

      *****************************************************************
      * The following buffers are used to create a four-byte status   *
      * code that may be displayed.                                   *
      *****************************************************************
       01  IO-STATUS.
           05  IO-STAT1            pic X.
           05  IO-STAT2            pic X.
       01  IO-STATUS-04.
           05  IO-STATUS-0401      pic 9     value 0.
           05  IO-STATUS-0403      pic 999   value 0.
       01  TWO-BYTES-BINARY        pic 9(4)  BINARY.
       01  TWO-BYTES-ALPHA         redefines TWO-BYTES-BINARY.
           05  TWO-BYTES-LEFT      pic X.
           05  TWO-BYTES-RIGHT     pic X.

      *****************************************************************
      * Message Buffer used by the Z-DISPLAY-MESSAGE-TEXT routine.    *
      *****************************************************************
       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* CALLPEC2 '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(68)   value SPACES.
               10  MESSAGE-TEXT-2  pic X(188)  value SPACES.

      *****************************************************************
       01  PROGRAM-NAME            pic X(8)     value 'CALLPEC2'.

       01  APPL-RESULT             pic S9(9)    comp.
           88  APPL-AOK            value 0.
           88  APPL-EOF            value 16.

       COPY PASSEX80.

      *****************************************************************
       PROCEDURE DIVISION.

           evaluate PASS-EX80-REQUEST
             when 'PUT ' move PASS-EX80-DATA to SIMOSEQ1-DATA-01
                         perform SIMOSEQ1-WRITE
             when 'OPEN' perform SIMOSEQ1-OPEN
             when 'CLOZ' perform SIMOSEQ1-CLOSE
             when other  add 16 to ZERO giving RETURN-CODE
                         move 0016 to PASS-EX80-RESPOND
           end-evaluate

           GOBACK.

      *****************************************************************
      * I/O Routines for the OUTPUT File...                           *
      *****************************************************************
       SIMOSEQ1-WRITE.
           if  SIMOSEQ1-OPEN-FLAG = 'C'
               perform SIMOSEQ1-OPEN
           end-if
           write SIMOSEQ1-REC
           if  SIMOSEQ1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  SIMOSEQ1-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if.
           if  APPL-AOK
               CONTINUE
           else
               move 'WRITE Failure with SIMOSEQ1' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move SIMOSEQ1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       SIMOSEQ1-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open OUTPUT SIMOSEQ1-FILE
           if  SIMOSEQ1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to SIMOSEQ1-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'OPEN Failure with SIMOSEQ1' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move SIMOSEQ1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       SIMOSEQ1-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close SIMOSEQ1-FILE
           if  SIMOSEQ1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'C' to SIMOSEQ1-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CLOSE Failure with SIMOSEQ1' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move SIMOSEQ1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * The following Z-ROUTINES provide administrative functions     *
      * for this program.                                             *
      *****************************************************************
      * ABEND the program, post a message to the console and issue    *
      * a STOP RUN.                                                   *
      *****************************************************************
       Z-ABEND-PROGRAM.
           if  MESSAGE-TEXT not = SPACES
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           move 'PROGRAM-IS-ABENDING...'  to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT
           add 12 to ZERO giving RETURN-CODE
           STOP RUN.
      *    exit.

      *****************************************************************
      * Display CONSOLE messages...                                   *
      *****************************************************************
       Z-DISPLAY-MESSAGE-TEXT.
           if MESSAGE-TEXT-2 = SPACES
               display MESSAGE-BUFFER(1:79)
           else
               display MESSAGE-BUFFER
           end-if
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
      * Display the file status bytes. This routine will display as   *
      * four digits. If the full two byte file status is numeric it   *
      * will display as 00nn. If the 1st byte is a numeric nine (9)   *
      * the second byte will be treated as a binary number and will   *
      * display as 9nnn.                                              *
      *****************************************************************
       Z-DISPLAY-IO-STATUS.
           if  IO-STATUS not NUMERIC
           or  IO-STAT1 = '9'
               move IO-STAT1 to IO-STATUS-04(1:1)
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move IO-STAT2 to TWO-BYTES-RIGHT
               add TWO-BYTES-BINARY to ZERO giving IO-STATUS-0403
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-04 to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           else
               move '0000' to IO-STATUS-04
               move IO-STATUS to IO-STATUS-04(3:2)
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-04 to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           exit.
      *****************************************************************
      *             A product of SimoTime Technologies                *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
