@echo OFF
rem  * *******************************************************************
rem  *               CALLPEE1.CMD - a Windows Command File               *
rem  *         This program is provided by SimoTime Technologies         *
rem  *           (C) Copyright 1987-2019 All Rights Reserved             *
rem  *             Web Site URL:   http://www.simotime.com               *
rem  *                   e-mail:   helpdesk@simotime.com                 *
rem  * *******************************************************************
rem  *
rem  * Text   -   Procedure Pointer with External Data Items.
rem  * Author -   SimoTime Enterprises
rem  * Date   -   January 01, 2006
rem  *
rem  * This set of COBOL programs will use a prodedure pointer to transfer
rem  * control between a mainline program to an I/O module to create a new
rem  * sequential file with 80-byte, fixed-length records. The parameters
rem  * are passed (or shared) using EXTERNAL Data Items.
rem  * A LINKAGE Section is not required in the I/O module.
rem  *
rem  * ********************************************************************
rem  * Step 1 of 2, Set the global environment variables...
rem  *
     setlocal
     call ..\Env1BASE
     if "%SYSLOG%" == "" set syslog=c:\SimoLIBR\LOGS\SimoTime.LOG
rem  *
     call SimoNOTE "*******************************************************CallPeE1"
     call SimoNOTE "Starting JobName CallPeE1"
rem  * ********************************************************************
rem  * Step 2 of 2, Execute the sample program...
rem  *
     set SIMOSEQ1=%BaseLib1%\DATA\Wrk1\SimoSeq1.DAT
     echo %SYSOUT%
     run CALLPEC1
     if ERRORLEVEL = 1 set JobStatus=0001
     if not "%JobStatus%" == "0000" goto :EojNOK
:EojAOK
     call SimoNOTE "Finished JobName CallPeE1, Job Status is %JobStatus%"
     goto :End
:EojNOK
     call SimoNOTE "ABENDING JobName CallPeE1, Job Status is %JobStatus%"
     goto :End
:End
     call SimoNOTE "Conclude SysLog is %SYSLOG%"
     if not "%1" == "nopause" pause
     endlocal
